# -*- perl -*-

#
# $Id: CNetFilePerl.pm,v 1.2 2002/07/13 21:02:49 eserte Exp $
# Author: Slaven Rezic
#
# Copyright (C) 2001 Slaven Rezic. All rights reserved.
#
# Mail: slaven.rezic@berlin.de
# WWW:  http://bbbike.sourceforge.net
#

package Strassen::CNetFilePerl;

package Strassen::CNetFile;

sub make_net {
    my($self) = @_;
    my $cache_prefix = Strassen::Util::get_cachefile($self->get_cachefile);

    require Strassen::Build;
    require Storable;

    $self->create_mmap_net_if_needed($cache_prefix);
    Strassen::CNetFile::mmap_net_file($self, $self->filename_c_net_mmap($cache_prefix));
    $self->{CNetCoord2Ptr} = Storable::retrieve($self->filename_c_net_coord2ptr($cache_prefix));
    $self->{Net2Name} = Storable::retrieve($self->filename_c_net_net2name($cache_prefix));

    if ($StrassenNetz::VERBOSE) {
	warn "Strassen::CNetFile::make_net finished\n";
    }

    $self;
}

1;
