#!/usr/bin/perl -w
# -*- perl -*-

#
# $Id: db_impl.t,v 1.4 2002/01/03 22:20:19 eserte Exp $
# Author: Slaven Rezic
#
# Copyright (C) 2001 Slaven Rezic. All rights reserved.
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
#
# Mail: slaven.rezic@berlin.de
# WWW:  http://www.rezic.de/eserte/
#

BEGIN {
# ***FILTER=1***
    print "1..1\nok 1\n"; exit;
# ***FILTER=all***
}

use Cwd;
BEGIN { $root = "../.." }
use lib ($root, "$root/lib", "$root/data");
use lib @lib::ORIG_INC;
use Strassen;
use Strassen::Build;
use Strassen::CNetFile;
use Storable;
require Strassen::Inline2;
Inline->init;

BEGIN {
    if (!eval q{
	use Test;
	1;
    }) {
	print "# tests only work with installed Test module\n";
	print "1..1\n";
	print "ok 1\n";
	exit;
    }

    $tests = 6;
}

BEGIN { plan tests => $tests }

my $start_coord = "9222,8787";
my $goal1_coord = "9327,9657";
my $goal2_coord = "13601,11518";

ok(1);
ok(defined &Strassen::Inline2::search_c);

my $net = StrassenNetz->new(Strassen->new("strassen"));
#  my $prefix = "/tmp/test_strassen";

#  ok($net->create_mmap_net_if_needed($prefix));

#  ok(Strassen::CNetFile::mmap_net_file($net, $net->filename_c_net_mmap($prefix)));
#  $net->{CNetCoord2Ptr} = retrieve($net->filename_c_net_coord2ptr($prefix));
#  ok($net->{CNetCoord2Ptr});
#  ok(exists $net->{CNetCoord2Ptr}{$start_coord});

Strassen::CNetFile::make_net($net);

@arr = Strassen::Inline2::search_c($net, $start_coord, $goal1_coord);
ok(@arr);
ok(ref $arr[0] eq 'ARRAY');

@arr = Strassen::Inline2::search_c($net, $start_coord, $goal2_coord);
ok(@arr);
ok(ref $arr[0] eq 'ARRAY');

use Data::Dumper; print STDERR "Line " . __LINE__ . ", File: " . __FILE__ . "\n" . Data::Dumper->Dumpxs([@arr],[]); # XXX


__END__
